<template>
  <div
    class="table"
    :class="{
      ['table--is-scrollable']: isScrollable
    }"
  >
    <div
      v-if="isScrollable"
      ref="vScrollbar"
      class="table__scroll table__scroll--vertical"
      :style="{
        top: `${headHeight}px`
      }"
    >
      <div
        ref="vTrack"
        class="table__scroll-track table__scroll-track--vertical"
        :draggable="true"
        @drag="e => handleThumb('v')(e)"
      />
    </div>
    <div
      v-if="isScrollable"
      ref="hScrollbar"
      class="table__scroll table__scroll--horizontal"
    >
      <div
        ref="hTrack"
        class="table__scroll-track table__scroll-track--horizontal"
        :draggable="true"
        @drag="e => handleThumb('h')(e)"
      />
    </div>
    <div
      ref="content"
      class="table__content"
      @scroll="handleScroll"
    >
      <table
        ref="table"
        class="table__table"
      >
        <thead ref="head">
          <tr>
            <th
              v-for="column in columns"
              :key="column.key"
            >
              <slot :name="`${column.key}-column`">
                <span>{{ column.text }}</span>
              </slot>
              <hr>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="row in data"
            :key="data[keyField ? row.raw[keyField] : 'index']"
          >
            <td
              v-for="column in columns"
              :key="column.key"
            >
              <slot
                :name="column.key"
                :row="row.raw"
                :index="row.index"
                :column="column"
              >
                {{ row.raw[column.key] }}
              </slot>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import bpMixin from '../../mixins/bpMixin';

export default {
  name: 'Table',
  mixins: [bpMixin],
  props: {
    isScrollable: Boolean,
    keyField: {
      type: String,
      default: undefined,
    },
    columns: {
      type: Array,
      default: () => ([]),
    },
    data: {
      type: Array,
      default: () => ([]),
    },
  },
  data() {
    return {
      headHeight: 0,
    };
  },
  watch: {
    async bp() {
      await this.$nextTick;
      this.computeHeadHeight();
    },
  },
  mounted() {
    this.computeHeadHeight();

    this.handleScroll();

    window.addEventListener('resize', this.handleScroll);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.handleScroll);
  },
  methods: {
    handleThumb(/* type */) {
      return (/* e */) => {
        // @TODO: handle thumb
      };
    },
    computeHeadHeight() {
      this.headHeight = this.$refs.head.offsetHeight;
    },
    handleScroll() {
      const {
        content, table, vTrack, hTrack, vScrollbar, hScrollbar,
      } = this.$refs;

      const {
        offsetHeight, scrollTop, offsetWidth, scrollLeft,
      } = content;
      const { offsetHeight: contentHeight, scrollWidth: contentWidth } = table;

      const height = (offsetHeight / contentHeight) * 100;
      const top = (scrollTop / contentHeight) * 100;

      const width = (offsetWidth / contentWidth) * 100;
      const left = (scrollLeft / contentWidth) * 100;

      vScrollbar.style.display = height >= 100 ? 'none' : 'initial';
      vTrack.style.height = `${height}%`;
      vTrack.style.top = `${top}%`;

      hScrollbar.style.display = width >= 100 ? 'none' : 'initial';
      hTrack.style.width = `${width}%`;
      hTrack.style.left = `${left}%`;
    },
  },
};
</script>

<style lang="scss">
  @import "./table";
</style>
